      program Dpol
      character cmdlin*256
      external  intrpt
      common  //loc,irun
      if (iargc().eq.0) goto 02000
      call getarg(1,cmdlin)
      read(cmdlin,*,err=09000) loc
01000 if (loc.ge.1.and.loc.le.3) goto 10000
      write(0,'(/2A)') 'Invalid Option Number !!',char(7)
02000 write(0,'(/A/A/A/A/$A)')
     &     'Deuteron-Beam Polarization Monitor at',
     &     '  1: D-room',
     &     '  2: Swinger eXit',
     &     '  3: Swinger eXit using T20=0',
     &     'Select [1..3] => '
      read(5,*,err=09000) loc
      goto 01000
09000 write(0,'(/2A)') 'Illigal Format !!',char(7)
      goto 02000

10000 call signal(2,intrpt,-1)
      write(6,'(A)') char(27)//'[?25l'//char(27)//'[H'//char(27)//'[2J'
      do while (.true.)
         write(6,'($A)') char(27)//'[H'
         call update(6)
         call sleep(4)
      enddo
      end

      subroutine update(iunit)
      integer*4 sumscl(0:15,8)
      character title(3)*50
      integer*4 nst(3),nsub(3)
      character sclnam(0:15,3)*10
      logical*4 disply(0:15,3)
      real*4     L (0:3), R (0:3), U (0:3), D (0:3), Y (0:3,4)
      real*4    dL2(0:3),dR2(0:3),dU2(0:3),dD2(0:3),dY2(0:3,4)
      equivalence
     &     ( L , Y (0,1)),( R , Y (0,2)),( U , Y (0,3)),( D , Y (0,4)),
     &     (dL2,dY2(0,1)),(dR2,dY2(0,2)),(dU2,dY2(0,3)),(dD2,dY2(0,4))
      real*4    py(3),dpy(3),px(3),dpx(3)
      real*4    pzz(3),dpzz(3),pzz2(3),dpzz2(3)
      real*4    Ay(3),Ayy(3),Axx(3)
      character coment*80,statim*8,stadat*9,stotim*8,stodat*9
      common  //loc,irun
      data   title/
     &     ' Polarization Monitor @ D-room ',
     &     ' Polarization Monitor @ Swinger-eXit ',
     &     ' Polarization Monitor @ Swinger-eXit using T20=0 '/
      data   nst/1,5,5/,nsub/3,1,1/
      data   sclnam/
     &     'Clock','B.I.','Trigger','Accept',
     &     'Left -True','Right-True','Up   -True','Down -True',
     &     'Left -Acc.','Right-Acc.','Up   -Acc.','Down -Acc.',4*' ',
     &     'Clock','B.I.',
     &     'Left -True','Right-True','Up   -True','Down -True',
     &     'Left -Acc.','Right-Acc.','Up   -Acc.','Down -Acc.',6*' ',
     &     'Clock','B.I.',
     &     'Left -True','Right-True','Up   -True','Down -True',
     &     'Left -Acc.','Right-Acc.','Up   -Acc.','Down -Acc.',6*' '/
      data   disply/2*.true.,2*.false.,8*.true.,4*.false.,
     &             10*.true.,6*.false.,
     &             10*.true.,6*.false./
      data   Ay  /-0.381, 2*-0.391/ ! 86.5-deg, 90.0-deg.
      data   Ayy /+0.491, 2*+0.478/
      data   Axx /-0.492, 2*-0.450/

      write(iunit,'(A)') title(loc)(:length(title(loc)))
      call gethdr(irun,coment,statim,stadat,stotim,stodat)
      write(iunit,'(X,A,I4.4)') 'RUN-',irun
      write(iunit,'(X,A)') coment(:79)
      call getscl(sumscl)
      write(iunit,'(7X,A,4(A13,I1))') 'Scalers   ',('mode#',i,i=0,3)
      do j=0,15
         if (disply(j,loc)) write(iunit,'(7X,A,4I14)')
     &        sclnam(j,loc),(sumscl(j,i),i=nst(loc),nst(loc)+3)
      enddo
c     normalize by B.I.
      n=0
      do i=nst(loc),nst(loc)+3
         BI=0.
         if (loc.ne.3) then
            BI=sumscl(1,i)
         else
            do j=1,4
               denom=float(sumscl(j+nsub(loc)  ,nst(loc))
     &                    -sumscl(j+nsub(loc)+4,nst(loc)))
               if (denom.ne.0.)
     &              BI=BI+float(sumscl(j+nsub(loc)  ,i)
     &                         -sumscl(j+nsub(loc)+4,i))/denom
            enddo
         endif
         do j=1,4
            if (BI.gt.0.) then
               Y (n,j)=(sumscl(j+nsub(loc)  ,i)
     &                 -sumscl(j+nsub(loc)+4,i))/BI
               dY2(n,j)=(sumscl(j+nsub(loc)  ,i)
     &                  +sumscl(j+nsub(loc)+4,i))/BI**2
            else
                Y (n,j)=0.
               dY2(n,j)=0.
            endif
         enddo
         n=n+1
      enddo
c     normalize by Unpol.
      do i=1,3
         do j=1,4
            if (Y(0,j).gt.0..and.Y(i,j).gt.0.) then
                w      =Y(i,j)/Y(0,j)
               dY2(i,j)=w*w*(dY2(i,j)/Y(i,j)**2+dY2(0,j)/Y(0,j)**2)
                Y (i,j)=w
            else
                Y (i,j)=0.
               dY2(i,j)=0.
            endif
         enddo
      enddo
c     polarizations
      do i=1,3
          py  (i)=    ( L (i)- R (i))/    Ay(loc) /3.
         dpy  (i)=sqrt(dL2(i)+dR2(i))/abs(Ay(loc))/3.
          px  (i)=    ( D (i)- U (i))/    Ay(loc) /3.
         dpx  (i)=sqrt(dD2(i)+dU2(i))/abs(Ay(loc))/3.
          pzz (i)=((L(i)+R(i)-2)/Ayy(loc)+(U(i)+D(i)-2)/Axx(loc))/2.
         dpzz (i)=sqrt((dL2(i)+dR2(i))/Ayy(loc)**2
     &                +(dU2(i)+dD2(i))/Axx(loc)**2)/2.
          pzz2(i)=((L(i)+R(i))-(U(i)+D(i)))/(Ayy(loc)-Axx(loc))
         dpzz2(i)=sqrt(dL2(i)+dR2(i)+dU2(i)+dD2(i))
     &                                  /abs(Ayy(loc)-Axx(loc))
      enddo
      write(iunit,'(13X,A12,3(A11,I1))')
     &             'Polarization',('mode#',i,i=1,3)
      write(iunit,30000) 'py    ',( py   (i),i=1,3)
      write(iunit,30000) ' err  ',(dpy   (i),i=1,3)
      write(iunit,30000) 'px    ',( px   (i),i=1,3)
      write(iunit,30000) ' err  ',(dpx   (i),i=1,3)
      write(iunit,30000) 'pxx-yy',( pzz2(i),i=1,3)
      write(iunit,30000) ' err  ',(dpzz2(i),i=1,3)
      write(iunit,30000) 'pzz   ',( pzz (i),i=1,3)
      write(iunit,30000) ' err  ',(dpzz (i),i=1,3)
30000 format(19X,A6,3F12.5)
      return
      end

      subroutine intrpt
      character flname*11,yn
      logical   exist
      common  //loc,irun
      write(flname,'(A,I4.4,A)') 'sca',irun,'.dat'
10000 write(0,'($A)') char(27)//'[H'//char(27)//'[2J'//
     &     'Write Data to File "'//flname//'" [y]/n ? '
      read(5,'(A)') yn
      if (yn.eq.'y'.or.yn.eq.'Y'.or.yn.eq.' ') then
         inquire(file=flname,exist=exist)
         if (exist) call rename(flname,flname//'~')
         open(1,file=flname,status='unknown')
         call update(1)
         close(1)
         write(0,'(/A/)') 'Data has been written to File.'
      else if (yn.ne.'n'.and.yn.ne.'N') then
         goto 10000
      endif
      write(6,'(A)') char(27)//'[?25h'
      stop
      end

      FUNCTION LENGTH(S)
      CHARACTER S*(*)
      LENGTH=LEN(S)
   10 IF (LENGTH.LE.0) RETURN
      IF (LGT(S(LENGTH:LENGTH),' ')) RETURN
      LENGTH=LENGTH-1
      GOTO 10
      END
